package com.lining.code.spark.material.model;

import com.lining.code.constant.ESIndexConstant;
import com.lining.code.constant.SQLConstant;
import com.lining.code.enums.DataFlowEnum;
import com.lining.code.enums.DataTypeEnum;
import com.lining.code.util.SparkSessionUtil;
import org.apache.spark.sql.Dataset;
import org.apache.spark.sql.Row;
import org.apache.spark.sql.SaveMode;
import org.apache.spark.sql.SparkSession;

import java.text.MessageFormat;

/**
 * @ Author ：lining.
 * @ Date ：Created in 18:07 2022/5/11
 * @ Description：可玩广告模型数据同步
 */
public class PreplayMaterialModelAction {

    public static void main(String[] args) {
        SparkSession sparkSession = SparkSessionUtil.getSparkSession("PreplayMaterialModelAction");

        String type = args[0];
        DataFlowEnum dataFlow = DataFlowEnum.getDataFlow(type);

        String gameSQL = MessageFormat.format(SQLConstant.PREPLAY_MATERIAL_MODEL_SQL,
                DataTypeEnum.GAME.getType(), dataFlow.getType());

        Dataset<Row> gameSet = sparkSession.sql(gameSQL);

        String gameIndex = MessageFormat.format(ESIndexConstant.PREPLAY_MATERIAL_INDEX,
                DataTypeEnum.GAME.getName());

        gameSet.write()
                .format("org.elasticsearch.spark.sql")
                .mode(SaveMode.Append)
                .option("es.mapping.id", "id")
                .save(gameIndex);

        /*String appSQL = MessageFormat.format(SQLConstant.PREPLAY_MATERIAL_MODEL_SQL,
                DataTypeEnum.APP.getType(), dataFlow.getType());

        Dataset<Row> appSet = sparkSession.sql(appSQL);

        String appIndex = MessageFormat.format(ESIndexConstant.PREPLAY_MATERIAL_INDEX,
                DataTypeEnum.APP.getName());

        appSet.write()
                .format("org.elasticsearch.spark.sql")
                .mode(SaveMode.Append)
                .option("es.mapping.id", "id")
                .save(appIndex);*/

        sparkSession.stop();

    }

}
