package com.lining.code.util;

import org.apache.commons.lang.StringUtils;

import java.io.InputStream;
import java.util.Map;
import java.util.Properties;

/**
 * @ Author ：lining.
 * @ Date ：Created in 16:32 2022/5/8
 * @ Description：配置属性读取
 */
public class PropertiesUtil {
    private static Properties prop = null;
    static{
        //获取配置
        try {
            prop = new Properties();
            ClassLoader loader = Thread.currentThread().getContextClassLoader();
            InputStream inputStream = loader.getResourceAsStream("config.properties");
            prop.load(inputStream);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static String getProperty(String property){
        return prop.getProperty(property);
    }

    public static String getProperty(String property,String defaultValue){
        String value = prop.getProperty(property);
        if(value == null || "".equals(value)){
            value = defaultValue;
        }
        return value;
    }

    public static String getStrValue(Map map, String key) {
        if (map == null || map.isEmpty() || StringUtils.isBlank(key)) {
            return "";
        }
        Object t = map.get(key);
        if (t != null) {
            if(t instanceof Integer){
                return t+"";
            }
            return t.toString();
        } else {
            for (Object o : map.keySet()) {
                String name = (String) o;
                if (name.toLowerCase().equals(key.toLowerCase())) {
                    Object value = map.get(o);
                    if (value == null) {
                        return "";
                    }
                    return value.toString();
                }
            }
        }

        return "";
    }
}
