package com.lining.code.util;


import org.apache.spark.sql.SparkSession;

/**
 * @ Author ：lining.
 * @ Date ：Created in 20:57 2022/5/10
 * @ Description：spark session 会话工具类
 */
public class SparkSessionUtil {

    public static SparkSession getSparkSession(String appName){

        SparkSession sparkSession = org.apache.spark.sql.SparkSession.builder().appName(appName) // .master("local[*]")
                .config("spark.files.ignoreMissingFiles",true) //解决分区损坏问题
                .config("spark.hadoop.yarn.timeline-service.enabled",false)//java.lang.NoClassDefFoundError: com/sun/jersey/api/client/config/ClientConfig
                .config("spark.sql.broadcastTimeout", PropertiesUtil.getProperty("spark.sql.broadcastTimeout","3600"))
                .config("spark.network.timeout",PropertiesUtil.getProperty("spark.network.timeout"))
                .config("spark.sql.parquet.compression.codec",PropertiesUtil.getProperty("spark.sql.parquet.compression.codec","gzip"))
                .config("es.index.auto.create", "true")//不自动建立，提早建立索引
                .config("es.nodes",PropertiesUtil.getProperty("es.nodes"))
                .config("es.port",PropertiesUtil.getProperty("es.port"))
                .config("es.net.http.auth.user",PropertiesUtil.getProperty("es.net.http.auth.user"))
                .config("es.net.http.auth.pass",PropertiesUtil.getProperty("es.net.http.auth.pass"))
                .config("es.batch.size.bytes",PropertiesUtil.getProperty("es.batch.size.bytes"))
                .config("es.batch.size.entries",PropertiesUtil.getProperty("es.batch.size.entries","100")) // 100 解决Could not write all entries
                .config("es.batch.write.refresh",PropertiesUtil.getProperty("es.batch.write.refresh","false"))
                .config("es.batch.write.retry.count",PropertiesUtil.getProperty("es.batch.write.retry.count","30")) // 3 解决Could not write all entries
                .config("es.batch.write.retry.wait",PropertiesUtil.getProperty("es.batch.write.retry.wait","100")) // 10s 解决Could not write all entries
                .config("es.http.timeout",PropertiesUtil.getProperty("es.http.timeout"))
                .config("es.http.retries",PropertiesUtil.getProperty("es.http.retries"))
                .config("es.action.heart.beat.lead",PropertiesUtil.getProperty("es.action.heart.beat.lead"))
                .config("es.nodes.wan.only",PropertiesUtil.getProperty("es.nodes.wan.only","true"))
                .config("es.nodes.data.only",PropertiesUtil.getProperty("es.nodes.data.only","true"))
                .config("es.nodes.discovery",PropertiesUtil.getProperty("es.nodes.discovery","true"))
                .config("es.input.use.sliced.partitions",PropertiesUtil.getProperty("es.input.use.sliced.partitions","50000"))
                .config("es.input.max.docs.per.partition",PropertiesUtil.getProperty("es.input.max.docs.per.partition","100000"))
                .config("es.net.http.header.Accept-Languag",PropertiesUtil.getProperty("es.net.http.header.Accept-Languag","gzip"))
                .enableHiveSupport().getOrCreate();

        return sparkSession;
    }
}
